<?php
/*
Plugin Name: PageRank Widget
Plugin URI: http://geeklad.com/wordpress-pagerank-widget-plugin
Description: Display your PageRank on your WordPress website.  Forget about other complicated PageRank plugins that require the modification of templates with additional PHP code. This plugin simplifies the display of your PageRank by simply displaying it as a widget.  Display your PageRank at a top-domain level or an individual page level.
Author: GeekLad
Version: 0.4
Author URI: http://geeklad.com/
*/

function control_pageRankWidget() {
	$options = $newoptions = get_option('widget_pageRankWidget');
	if ( $_POST["pagerank-widget-submit"] ) {
		$newoptions['level'] = $_POST["pagerank-widget-level"];
	}
	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('widget_pageRankWidget', $options);
	}
	if ( empty($options['level']) )
		$level = "pages";
	else
		$level = $options['level'];
?>
			<p><label for="pagerank-widget-title"><?php _e('Display top-level PageRank, or individual pages?<br>'); ?><select id="pagerank-widget-level" name="pagerank-widget-level"><option value="pages"<?php if($level == "pages") echo ' selected="selected"'; ?>>Individual Pages</option><option value="top"<?php if($level == "top") echo ' selected="selected"'; ?>>Top-Level</option></select>
				<br />
			</p>
			<input type="hidden" id="pagerank-widget-submit" name="pagerank-widget-submit" value="1" />
<?php
}

function widget_pageRankWidget() {
//	extract($args);
	$options = get_option('widget_pageRankWidget');
	if ( empty($options['level']) )
		$level = "pages";
	else
		$level = $options['level'];
	
	if ($level == "pages")
		echo display_pageRankWidget($_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"]);
	else
		echo display_pageRankWidget($_SERVER["HTTP_HOST"]);
}

function display_pageRankWidget($url) {
	$pagerank = getpr($url);
	if (empty ($pagerank))
		$pagerank = "N/A";
		
	$output = '<span id="pagerank-widget" style="font-family: Tahoma,Verdana,Arial; font-size: 12px; line-height=12px;">';
	$output .= '	<p></p>';
	$output .= '	<table cellspacing="0" cellpadding="5" style="border: 1px solid black;">';
	$output .= '		<tr>';
	$output .= '			<td align="center" style="line-height: 7px">PageRank</td>';
	$output .= '			<td style="margin: 5px; padding: 10px; background: #008000; font-size: 20px; color: #FFFFFF; line-height: 7px; font-family: Arial;" rowspan="2">' . $pagerank . '</td>';
	$output .= '		</tr>';
	$output .= '		<tr>';
	$output .= '		<td>';
	$output .= '				<table cellspacing="0" cellpadding="0" width="60px" height="8px" style="border: 1px solid black;">';
	$output .= '					<tr>';
	if ($pagerank == "N/A") {
		$output .= '						<td style="width: 80px; background: #808080;"></td>';
	} else {
		$x = (int) $x;
		for ($x=1; $x<=$pagerank; $x++) {
			$output .= '						<td style="background: #008000; width: 8px"></td>';
		}		
		for ($x=$x; $x<=10; $x++) {
			$output .= '						<td style="background: #FFFFFF; width: 8px"></td>';
		}
	}
	$output .= '					</tr>';
	$output .= '				</table>';
	$output .= '			</td>';
	$output .= '		</tr>';
	$output .= '	</table>';
	$output .= '	<span style="font-size: 9px; line-height:9px;">Powered by <a href="http://geeklad.com/wordpress-pagerank-widget-plugin">PageRank Widget</a></span>';
	$output .= '</span>';
	return $output;
}

function post_pageRankWidget($content) {
	if( preg_match('/<!--pagerank-->/i', $content)) {
		$splitcontent = preg_split('/<!--pagerank-->/i', $content, 2);
		$content = $splitcontent[0] . display_pageRankWidget($_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"]) . $splitcontent[1];
	}
	return $content;
}

// This is the actual PageRank checking code
// Got this script from http://www.diagnosticoweb.com/wdscript/free.php
function StrToNum($Str, $Check, $Magic)
{
$Int32Unit = 4294967296; // 2^32

$length = strlen($Str);
for ($i = 0; $i < $length; $i++) {
$Check *= $Magic;
if ($Check >= $Int32Unit) {
$Check = ($Check - $Int32Unit * (int) ($Check / $Int32Unit));
$Check = ($Check < -2147483648) ? ($Check + $Int32Unit) : $Check;
}
$Check += ord($Str{$i});
}
return $Check;
}

/*
* Generate a hash for a url
*/
function HashURL($String)
{
$Check1 = StrToNum($String, 0x1505, 0x21);
$Check2 = StrToNum($String, 0, 0x1003F);

$Check1 >>= 2;
$Check1 = (($Check1 >> 4) & 0x3FFFFC0 ) | ($Check1 & 0x3F);
$Check1 = (($Check1 >> 4) & 0x3FFC00 ) | ($Check1 & 0x3FF);
$Check1 = (($Check1 >> 4) & 0x3C000 ) | ($Check1 & 0x3FFF);

$T1 = (((($Check1 & 0x3C0) << 4) | ($Check1 & 0x3C)) <<2 ) | ($Check2 & 0xF0F );
$T2 = (((($Check1 & 0xFFFFC000) << 4) | ($Check1 & 0x3C00)) << 0xA) | ($Check2 & 0xF0F0000 );

return ($T1 | $T2);
}

/*
* generate a checksum for the hash string
*/
function CheckHash($Hashnum)
{
$CheckByte = 0;
$Flag = 0;

$HashStr = sprintf('%u', $Hashnum) ;
$length = strlen($HashStr);

for ($i = $length - 1; $i >= 0; $i --) {
$Re = $HashStr{$i};
if (1 === ($Flag % 2)) {
$Re += $Re;
$Re = (int)($Re / 10) + ($Re % 10);
}
$CheckByte += $Re;
$Flag ++;
}

$CheckByte %= 10;
if (0 !== $CheckByte) {
$CheckByte = 10 - $CheckByte;
if (1 === ($Flag % 2) ) {
if (1 === ($CheckByte % 2)) {
$CheckByte += 9;
}
$CheckByte >>= 1;
}
}

return '7'.$CheckByte.$HashStr;
}

function getpr($url) {
$query="http://gmodules.com/ig/proxy?up_update=86400&url=" . urlencode("http://toolbarqueries.google.com/search?client=navclient-auto&ch=".CheckHash(HashURL($url)). "&features=Rank&q=info:".$url."&num=100&filter=0");
$data=@implode("", file($query));

$pos = strpos($data, "Rank_");
if($pos === false){} else{
$pagerank = substr($data, $pos + 9);
return $pagerank;
}
}

function pageRankWidget_init()
{
	register_sidebar_widget(__('PageRank Widget'), 'widget_pageRankWidget');
	register_widget_control(__('PageRank Widget'), 'control_pageRankWidget');
}
add_action("plugins_loaded", "pageRankWidget_init");
add_filter("the_content", "post_pageRankWidget");
?>